]> git.cameronkatri.com Git - pw-darwin.git/blobdiff - adduser/adduser.sh
Assume manpages are compressed with zst
[pw-darwin.git] / adduser / adduser.sh
index 0014e4c107996779d0d1b475d5d3f3f055644dec..b9abd81e9eca9380e63e9cdfa86d907d342cb6e8 100644 (file)
@@ -1,5 +1,7 @@
 #!/bin/sh
 #
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
 # Copyright (c) 2002-2004 Michael Telahun Makonnen. All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without
 #
 
 # err msg
-#       Display $msg on stderr, unless we're being quiet.
-# 
+#      Display $msg on stderr, unless we're being quiet.
+#
 err() {
        if [ -z "$quietflag" ]; then
-               echo 1>&2 ${THISCMD}: ERROR: $*
+               echo 1>&2 ${THISCMD}: ERROR: $*
        fi
 }
 
 # info msg
-#       Display $msg on stdout, unless we're being quiet.
-# 
+#      Display $msg on stdout, unless we're being quiet.
+#
 info() {
        if [ -z "$quietflag" ]; then
-               echo ${THISCMD}: INFO: $*
+               echo ${THISCMD}: INFO: $*
        fi
 }
 
@@ -50,7 +52,7 @@ info() {
 #      is not, output the value of the next higher uid that is available.
 #      If a uid is not specified, output the first available uid, as indicated
 #      by pw(8).
-# 
+#
 get_nextuid () {
        _uid=$1
        _nextuid=
@@ -81,6 +83,7 @@ show_usage() {
        echo "  -E              disable this account after creation"
        echo "  -G              additional groups to add accounts to"
        echo "  -L              login class of the user"
+       echo "  -M              file permission for home directory"
        echo "  -N              do not read configuration file"
        echo "  -S              a nonexistent shell is not an error"
        echo "  -d              home directory"
@@ -162,8 +165,7 @@ fullpath_from_shell() {
 #      the path is invalid or it is not executable it
 #      will emit an informational message saying so.
 #
-shell_exists()
-{
+shell_exists() {
        _sh="$1"
        _shellchk="${GREPCMD} '^$_sh$' ${ETCSHELLS} > /dev/null 2>&1"
 
@@ -190,6 +192,7 @@ save_config() {
        echo "# NOTE: only *some* variables are saved." >> ${ADDUSERCONF}
        echo "# Last Modified on `${DATECMD}`."         >> ${ADDUSERCONF}
        echo ''                         >> ${ADDUSERCONF}
+       echo "defaultHomePerm=$uhomeperm" >> ${ADDUSERCONF}
        echo "defaultLgroup=$ulogingroup" >> ${ADDUSERCONF}
        echo "defaultclass=$uclass"     >> ${ADDUSERCONF}
        echo "defaultgroups=$ugroups"   >> ${ADDUSERCONF}
@@ -199,6 +202,7 @@ save_config() {
        echo "udotdir=$udotdir"         >> ${ADDUSERCONF}
        echo "msgfile=$msgfile"         >> ${ADDUSERCONF}
        echo "disableflag=$disableflag" >> ${ADDUSERCONF}
+       echo "uidstart=$uidstart"       >> ${ADDUSERCONF}
 }
 
 # add_user
@@ -246,7 +250,12 @@ add_user() {
                if [ "$uhome" = "$NOHOME" ]; then
                        _home='-d "$uhome"'
                else
-                       _home='-m -d "$uhome"'
+                       # Use home directory permissions if specified
+                       if [ -n "$uhomeperm" ]; then
+                               _home='-m -d "$uhome" -M "$uhomeperm"'
+                       else
+                               _home='-m -d "$uhome"'
+                       fi
                fi
        elif [ -n "$Dflag" -a -n "$uhome" ]; then
                _home='-d "$uhome"'
@@ -346,13 +355,19 @@ get_user() {
                        _input="`echo "$fileline" | cut -f1 -d:`"
                fi
 
-               # There *must* be a username. If this is an interactive
-               # session give the user an opportunity to retry.
+               # There *must* be a username, and it must not exist. If
+               # this is an interactive session give the user an
+               # opportunity to retry.
                #
                if [ -z "$_input" ]; then
                        err "You must enter a username!"
                        [ -z "$fflag" ] && continue
                fi
+               ${PWCMD} usershow $_input > /dev/null 2>&1
+               if [ "$?" -eq 0 ]; then
+                       err "User exists!"
+                       [ -z "$fflag" ] && continue
+               fi
                break
        done
        username="$_input"
@@ -442,6 +457,29 @@ get_homedir() {
        fi
 }
 
+# get_homeperm
+#      Reads the account's home directory permissions.
+#
+get_homeperm() {
+       uhomeperm=$defaultHomePerm
+       _input=
+       _prompt=
+
+       if [ -n "$uhomeperm" ]; then
+               _prompt="Home directory permissions [${uhomeperm}]: "
+       else
+               _prompt="Home directory permissions (Leave empty for default): "
+       fi
+       if [ -z "$fflag" ]; then
+               echo -n "$_prompt"
+               read _input
+       fi
+
+       if [ -n "$_input" ]; then
+               uhomeperm="$_input"
+       fi
+}
+
 # get_uid
 #      Reads a numeric userid in an interactive or batch session. Automatically
 #      allocates one if it is not specified.
@@ -451,10 +489,8 @@ get_uid() {
        _input=
        _prompt=
 
-       # No need to take down uids for a configuration saving run.
-       [ -n "$configflag" ] && return
-
        if [ -n "$uuid" ]; then
+               uuid=`get_nextuid $uuid`
                _prompt="Uid [$uuid]: "
        else
                _prompt="Uid (Leave empty for default): "
@@ -588,21 +624,23 @@ input_from_file() {
        while read -r fileline ; do
                case "$fileline" in
                \#*|'')
-                       return 0
                        ;;
-               esac
-
-               get_user || continue
-               get_gecos
-               get_uid
-               get_logingroup
-               get_class
-               get_shell
-               get_homedir
-               get_password
-               get_expire_dates
+               *)
+                       get_user || continue
+                       get_gecos
+                       get_uid
+                       get_logingroup
+                       get_class
+                       get_shell
+                       get_homedir
+                       get_homeperm
+                       get_password
+                       get_expire_dates
+                       ugroups="$defaultgroups"
 
-               add_user
+                       add_user
+                       ;;
+               esac
        done
 }
 
@@ -611,7 +649,6 @@ input_from_file() {
 #      the user database.
 #
 input_interactive() {
-
        _disable=
        _pass=
        _passconfirm=
@@ -665,6 +702,7 @@ input_interactive() {
        get_class
        get_shell
        get_homedir
+       get_homeperm
 
        while : ; do
                echo -n "Use password-based authentication? [$_usepass]: "
@@ -695,10 +733,10 @@ input_interactive() {
                                        trap 'stty echo; exit' 0 1 2 3 15
                                        stty -echo
                                        echo -n "Enter password: "
-                                       read -r upass
+                                       IFS= read -r upass
                                        echo''
                                        echo -n "Enter password again: "
-                                       read -r _passconfirm
+                                       IFS= read -r _passconfirm
                                        echo ''
                                        stty echo
                                        # if user entered a blank password
@@ -775,6 +813,7 @@ input_interactive() {
        printf "%-10s : %s\n" "Class" "$uclass"
        printf "%-10s : %s %s\n" "Groups" "${ulogingroup:-$username}" "$ugroups"
        printf "%-10s : %s\n" "Home" "$uhome"
+       printf "%-10s : %s\n" "Home Mode" "$uhomeperm"
        printf "%-10s : %s\n" "Shell" "$ushell"
        printf "%-10s : %s\n" "Locked" "$_disable"
        while : ; do
@@ -796,7 +835,7 @@ input_interactive() {
        return 0
 }
 
-#### END SUBROUTINE DEFENITION ####
+#### END SUBROUTINE DEFINITION ####
 
 THISCMD=`/usr/bin/basename $0`
 DEFAULTSHELL=/bin/sh
@@ -819,6 +858,7 @@ ugecos=
 ulogingroup=
 uclass=
 uhome=
+uhomeperm=
 upass=
 ushell=
 udotdir=/usr/share/skel
@@ -837,7 +877,7 @@ disableflag=
 Dflag=
 Sflag=
 readconfig="yes"
-homeprefix="/home"
+homeprefix="/var"
 randompass=
 fileline=
 savedpwtype=
@@ -845,9 +885,10 @@ defaultclass=
 defaultLgroup=
 defaultgroups=
 defaultshell="${DEFAULTSHELL}"
+defaultHomePerm=
 
 # Make sure the user running this program is root. This isn't a security
-# measure as much as it is a usefull method of reminding the user to
+# measure as much as it is a useful method of reminding the user to
 # 'su -' before he/she wastes time entering data that won't be saved.
 #
 procowner=${procowner:-`/usr/bin/id -u`}
@@ -856,7 +897,7 @@ if [ "$procowner" != "0" ]; then
        exit 1
 fi
 
-# Overide from our conf file
+# Override from our conf file
 # Quickly go through the commandline line to see if we should read
 # from our configuration file. The actual parsing of the commandline
 # arguments happens after we read in our configuration file (commandline
@@ -876,7 +917,7 @@ if [ -n "$readconfig" ]; then
        fi
 fi 
 
-# Proccess command-line options
+# Process command-line options
 #
 for _switch ; do
        case $_switch in
@@ -933,6 +974,10 @@ for _switch ; do
                esac
                shift; shift
                ;;
+       -M)
+               defaultHomePerm=$2
+               shift; shift
+               ;;
        -N)
                readconfig=
                shift